3 # Shell script to build Makefile in a build directory. It must be called
4 # from inside the directory. It does its own checking of when to rebuild; it
5 # just got too horrendous to get it right in "make", because of the optionally
6 # existing configuration files.
9 # First off, get the OS type, and check that there is a make file for it.
11 ostype=`../scripts/os-type -generic` || exit 1
13 if [ ! -r ../OS/Makefile-$ostype ] ; then
15 echo "*** Sorry - operating system $ostype is not supported"
16 echo "*** See OS/Makefile-* for supported systems" 1>&2
21 # We also need the architecture type, in order to test for any architecture-
22 # specific configuration files.
24 archtype=`../scripts/arch-type` || exit 1
26 # Now test for either the non-existence of Makefile, or for any of its
27 # components being newer. Note that the "newer" script gives the right
28 # answer (for our purposes) when the first file is non-existent.
30 editme=../Local/Makefile
33 if [ -f Makefile ] ; then
35 if ../scripts/newer $editme Makefile || \
36 ../scripts/newer $editme-$ostype Makefile || \
37 ../scripts/newer $editme-$archtype Makefile || \
38 ../scripts/newer $editme-$ostype-$archtype Makefile || \
39 ../scripts/newer ../scripts/Configure-Makefile Makefile || \
40 ../scripts/newer ../OS/Makefile-Base Makefile || \
41 ../scripts/newer ../OS/Makefile-Default Makefile
47 # If the "build" variable is set it means that a build name was explicitly
48 # given. Arrange to pick up a build-specific configuration file.
50 if [ "X$build" != "X" ] ; then
51 mfb=Local/Makefile-$build
52 if ../scripts/newer $editme-$build Makefile ; then
60 # If Makefile is up-to-date, no need to rebuild it.
62 if [ $rebuild = no ] ; then
63 echo "\`Makefile' is up to date."
68 # Makefile needs to be rebuilt in the current directory by joining
69 # the generic default makefile, the OS base makefile, and then local
70 # generic, OS-specific, architecture-specific, and OS+architecture-specific
71 # makefiles, if they exist. These files all contain macro definitions, with
72 # later definitions overriding earlier ones. Make a temporary file first, in
73 # case things go wrong. A second temporary is needed for sorting out the
74 # default Perl stuff. Use short macro names to save typing.
80 look_mf=lookups/Makefile
81 look_mf_pre=${look_mf}.predynamic
82 look_mf_post=${look_mf}.postdynamic
84 # Ensure the temporary does not exist and start the new one by setting
85 # the OSTYPE and ARCHTYPE variables.
87 rm -f $mft $mftt $look_mf-t
88 (echo "OSTYPE=$ostype"; echo "ARCHTYPE=$archtype"; echo "") > $mft || exit 1
90 # Now concatenate the files to the temporary file. Copy the files using sed to
91 # remove comments, blank lines, and trailing white space.
93 # BEWARE: a tab character is needed in the sed command below. It has had
94 # a nasty tendency to get lost in the past, causing a problem if a tab has
95 # actually been present in one of the files. Use a variable to hold a space
96 # and a tab to keep the tab in one place.
100 for f in OS/Makefile-Default \
101 OS/Makefile-$ostype \
103 Local/Makefile-$ostype \
104 Local/Makefile-$archtype \
105 Local/Makefile-$ostype-$archtype \
108 then echo "# From $f"
109 sed "/^#/d;/^[$st]*\$/d;s/[$st]*\$//" ../$f || exit 1
113 done >> $mft || exit 1
116 # beware portability of extended regexps with sed.
118 egrep "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
119 sed "s/[$st]*=/='/" | \
120 sed "s/\$/'/" > $mftt
121 egrep "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS|PCRE_CONFIG|AVOID_GNUTLS_PKCS11)[$st]*=[$st]*" $mft | \
122 sed "s/[$st]*=/='/" | \
123 sed "s/\$/'/" >> $mftt
127 echo "# pkg-config fixups"
129 for var in `cut -d = -f 1 < $mftt`; do
133 eval "pc_value=\"\$$var\""
135 if [ ".$SUPPORT_TLS" = "." ]; then
136 # no TLS, not referencing
138 elif [ ".$var" = ".USE_GNUTLS_PC" ] && [ ".$USE_GNUTLS" != "." ]; then
140 elif [ ".$var" = ".USE_OPENSSL_PC" ] && [ ".$USE_GNUTLS" = "." ]; then
143 if [ ".$need_this" != "." ]; then
144 tls_include=`pkg-config --cflags $pc_value`
145 if [ $? -ne 0 ]; then
146 echo >&2 "*** Missing pkg-config for package $pc_value (for Exim $var build option)"
149 tls_libs=`pkg-config --libs $pc_value`
150 echo "TLS_INCLUDE=$tls_include"
151 echo "TLS_LIBS=$tls_libs"
156 eval "pc_value=\"\$$var\""
157 base=`echo $var | sed 's/_PC$//'`
158 eval "basevalue=\"\$$base\""
159 if [ ".$basevalue" = "." ]; then
160 # not pulling in this module, _PC defined as default? Ignore
162 elif [ $basevalue = 2 ]; then
163 # module; handled in scripts/lookups-Makefile
167 cflags=`pkg-config --cflags $pc_value`
168 if [ $? -ne 0 ]; then
169 echo >&2 "*** Missing pkg-config for package $pc_value (for Exim $var build option)"
172 libs=`pkg-config --libs $pc_value`
173 if [ "$var" != "${var#LOOKUP_}" ]; then
174 echo "LOOKUP_INCLUDE += $cflags"
175 echo "LOOKUP_LIBS += $libs"
176 elif [ "$var" != "${var#AUTH_}" ]; then
177 echo "CFLAGS += $cflags"
178 echo "AUTH_LIBS += $libs"
180 echo >&2 "Don't know how to handle pkg-config for $var"
188 cflags=`pcre-config --cflags`
189 if [ $? -ne 0 ]; then
190 echo >&2 "*** Missing pcre-config for regular expression support"
193 libs=`pcre-config --libs`
194 if [ ".$cflags" != "." ]; then
195 echo "INCLUDE += $cflags"
197 echo "PCRE_LIBS=$libs"
208 echo "# End of pkg-config fixups"
212 if [ $subexit -ne 0 ]; then
218 # make the lookups Makefile with the definitions
219 # the auxiliary script generates $look_mf_post from $look_mf_pre
221 cp ../src/lookups/Makefile $look_mf_pre
222 ../scripts/lookups-Makefile
224 # See if there is a definition of EXIM_PERL in what we have built so far.
225 # If so, run Perl to find the default values for PERL_CC, PERL_CCOPTS,
226 # and PERL_LIBS. These need to be put at the top of the Makefile, so we rename
227 # what we have so far and then copy it afterwards. Use the value of PERL_COMMAND
228 # if it has been defined.
230 EXIM_PERL=`grep EXIM_PERL $mft`
232 PERL_COMMAND=`grep PERL_COMMAND $mft | sed -e "\\$!d;s/^[$st]*PERL_COMMAND[$st]*=[$st]*//"`
233 if [ "${PERL_COMMAND}" = "" ] ; then
237 if [ "${EXIM_PERL}" != "" ] ; then
238 testperl=`$PERL_COMMAND --version`
239 if [ "$testperl" = "" ] ; then
240 echo "*** EXIM_PERL is set, but '$PERL_COMMAND --version' failed"
244 EXTUTILS_EMBED_NOT_INSTALLED=`$PERL_COMMAND -MExtUtils::Embed -e ";" 2>&1`
245 if [ "${EXTUTILS_EMBED_NOT_INSTALLED}" != "" ] ; then
246 echo "Please install ExtUtils::Embed for $PERL_COMMAND"
251 echo "PERL_CC=`$PERL_COMMAND -MConfig -e 'print $Config{cc}'`" >>$mft
252 echo "PERL_CCOPTS=`$PERL_COMMAND -MExtUtils::Embed -e ccopts`" >>$mft
253 echo "PERL_LIBS=`$PERL_COMMAND -MExtUtils::Embed -e ldopts`" >>$mft
259 # Record the build variable in the Makefile.
261 echo "build=$build" >>$mft
264 # Finally, join on the generic base make file, which contains the actual
267 echo "# From ../OS/Makefile-Base" >> $mft
268 cat ../OS/Makefile-Base >> $mft || exit 1
270 # If the new makefile is the same as the existing one, say so, and just
271 # update the timestamp. Otherwise remove the old and install the new.
273 if [ -s $mf ] && cmp -s $mft $mf && [ -s $look_mf ] && cmp -s $look_mf_post $look_mf
274 then echo ">>> rebuilt $mf unchanged"
277 rm -f $mft $look_mf_pre $look_mf_post
278 elif rm -f $mf $look_mf $look_mf_pre
280 mv $look_mf_post $look_mf
281 then echo ">>> New $mf & $look_mf installed"
282 echo '>>> Use "make makefile" if you need to force rebuilding of the makefile'
285 echo "*** Failed to install $mf - see $mft"
286 echo " (or $look_mft)"
292 # End of Configure-Makefile